/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.task.field;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import nl.cloudfarming.client.isobus.model.ExportAction;
import nl.cloudfarming.client.model.Entity;
import nl.cloudfarming.client.task.ExportableTaskCapability;
import nl.cloudfarming.client.task.Task;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
public class TaskExportButton extends javax.swing.JPanel implements LookupListener {

    private Task task;
    
    /**
     * Creates new form TaskExportButton
     */
    public TaskExportButton() {
        initComponents();
        exportButton.addActionListener(new ExportActionListener());
    }
    
    public TaskExportButton(Task task) {
        this();
        setTask(task);
    }
    
    public void setTask(Task task) {
        this.task = task;
        task.getLookup().lookupResult(Entity.class).addLookupListener(this);
        exportButton.setEnabled(task.isComplete());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        exportButton = new javax.swing.JButton();

        exportButton.setText(org.openide.util.NbBundle.getMessage(TaskExportButton.class, "TaskExportButton.exportButton.text")); // NOI18N
        exportButton.setToolTipText(org.openide.util.NbBundle.getMessage(TaskExportButton.class, "TaskExportButton.exportButton.toolTipText")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(exportButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(exportButton)
                .addGap(0, 0, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton exportButton;
    // End of variables declaration//GEN-END:variables

    @Override
    public void resultChanged(LookupEvent ev) {
        exportButton.setEnabled(task.isComplete());
    }
    
    private class ExportActionListener implements ActionListener {

        @Override
        public void actionPerformed(ActionEvent e) {
            List<ExportableTaskCapability> exportableTasks = (List<ExportableTaskCapability>) task.getLookup().lookupAll(ExportableTaskCapability.class);
            ExportAction exportAction = new ExportAction(exportableTasks);
            exportAction.actionPerformed(null);
        }
        
    }
}
